> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Get the SQL query for a data model element

GET https://api.sigmacomputing.com/v2/dataModels/{dataModelId}/elements/{elementId}/query

This endpoint retrieves the underlying SQL query associated with a specific element in a data model. It allows users to view and understand how the data for that element is being processed and transformed, which is useful for debugging, optimization, and educational purposes.

### Usage notes

* Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.
* Retrieve the **elementId** by calling the [/v2/dataModels/\{dataModelId}/elements](https://help.sigmacomputing.com/reference/list-data-model-elements) endpoint.
* To retrieve the query for an element from a version-tagged data model, pass the `tagName` in the query parameters with the tag name. Retrieve the tag name by calling the [/v2/dataModels/\{dataModelId}/tags](https://help.sigmacomputing.com/reference/list-data-model-tags) endpoint and using the `tagName` included in the response for a given data model.

### Usage scenarios

* **Development and debugging:** Provides developers and analysts with the ability to retrieve and review the SQL code behind data model elements, facilitating troubleshooting and enhancements.
* **Educational insight:** Useful for training purposes or for users learning to understand the impact of various transformations and filters applied within their Sigma data models.

### Best practices

* Restrict who can retrieve query SQL with [folder and document permissions](https://help.sigmacomputing.com/docs/folder-and-document-permissions). [Column-level security (CLS)](https://help.sigmacomputing.com/docs/column-level-security) still applies to the data returned by those queries.
* Use this endpoint as part of a regular review process to ensure that all queries are optimized and up to date with current data schemas.

Reference: https://help.sigmacomputing.com/reference/get-data-model-element-query

## Authentication

- OAuth2 — send the obtained token as `Authorization: Bearer <token>`

## Servers

- `https://api.sigmacomputing.com` (Server for GCP (US) hosted organizations, default)
- `https://api.sa.gcp.sigmacomputing.com` (Server for GCP (KSA) hosted organizations)
- `https://aws-api.sigmacomputing.com` (Server for AWS US (West) hosted organizations)
- `https://api.us-a.aws.sigmacomputing.com` (Server for AWS US (East) hosted organizations)
- `https://api.ca.aws.sigmacomputing.com` (Server for AWS Canada hosted organizations)
- `https://api.eu.aws.sigmacomputing.com` (Server for AWS Europe hosted organizations)
- `https://api.au.aws.sigmacomputing.com` (Server for AWS Australia and APAC hosted organizations)
- `https://api.uk.aws.sigmacomputing.com` (Server for AWS UK hosted organizations)
- `https://api.us.azure.sigmacomputing.com` (Server for Azure US hosted organizations)
- `https://api.eu.azure.sigmacomputing.com` (Server for Azure Europe hosted organizations)
- `https://api.ca.azure.sigmacomputing.com` (Server for Azure Canada hosted organizations)
- `https://api.uk.azure.sigmacomputing.com` (Server for Azure United Kingdom hosted organizations)
- `https://api.au.azure.sigmacomputing.com` (Server for Azure Australia hosted organizations)

## Request

### Path parameters

- `dataModelId` (string, required)
- `elementId` (string, required)

### Query parameters

- `tagName` (string, optional)

## Response

### 200

The response body.

- `elementId` (string, required)
- `name` (string, optional)
- `sql` (string, optional)
- `error` (string, optional)

## Examples

**Response**

```json
{
  "elementId": "string",
  "name": "string",
  "sql": "string",
  "error": "string"
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/query"

headers = {"Authorization": "<token>."}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/query';
const options = {method: 'GET', headers: {Authorization: '<token>.'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/query"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "<token>.")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/query")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/query")
  .header("Authorization", "<token>.")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/query', [
  'headers' => [
    'Authorization' => '<token>.',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/query");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "<token>."]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/query")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```